<section>

    <mat-progress-bar *ngIf="loading" mode="indeterminate"></mat-progress-bar>
    <div class="title">
        <h1>CashOut Requests</h1>
        <hr>
    </div>
    <div class="container content">
        <div class="search-table" fxLayout="row">
            <img src="./assets/images/search.svg" alt="search">
            <input (keyup)="applyFilter($event)" placeholder="Search">
        </div>
        <mat-table [dataSource]="dataSource" matSort class="mat-elevation-z8">
            <!-- NO Column -->
            <ng-container matColumnDef="no">
                <mat-header-cell class="text-black" *matHeaderCellDef> No. </mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="No."> {{dataSource.filteredData.indexOf(element) + 1}}. </mat-cell>
            </ng-container>
            <!-- Room Name Column -->
            <ng-container matColumnDef="name">
                <mat-header-cell class="text-black" *matHeaderCellDef> Room Name </mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="Room Name"> {{element.event.eventName}} </mat-cell>
            </ng-container>

            <!-- Event Date Column -->
            <ng-container matColumnDef="date">
                <mat-header-cell class="text-black"  *matHeaderCellDef mat-sort-header>Event Date </mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="Event Date">{{getDate(element.event.eventDate)}} </mat-cell>
            </ng-container>

            <!-- Event Start Time Column -->
            <ng-container matColumnDef="start">
                <mat-header-cell class="text-black" *matHeaderCellDef> Start Time </mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="Start Time"> {{getTime(element.event.startTime)}} </mat-cell>
            </ng-container>

            <!-- Event End Time Column -->
            <ng-container matColumnDef="end">
                <mat-header-cell class="text-black" *matHeaderCellDef> End Time </mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="End Time"> {{getTime(element.event.endTime)}} </mat-cell>
            </ng-container>

            <!-- Host Name Column -->
            <ng-container matColumnDef="host">
                <mat-header-cell class="text-black"  *matHeaderCellDef>Host Name </mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="Host Name "> {{element.event.user.username}} </mat-cell>
            </ng-container>

            <!-- Amount Column -->
            <ng-container matColumnDef="amount">
                <mat-header-cell class="text-black" *matHeaderCellDef mat-sort-header> Amount ($)</mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="Amount ($)">{{element.amount}} </mat-cell>
            </ng-container>

            <!-- Action Column -->
            <ng-container matColumnDef="action">
                <mat-header-cell class="text-black" *matHeaderCellDef>Action/Status </mat-header-cell>
                <mat-cell *matCellDef="let element" data-label="Action/Status ">
                    <div fxLayout="row">
                        <button *ngIf="element.status == 'pending'" [disabled]="loading" class="btn-decline" (click)="decline(element.requestId)">Decline</button>
                        <button *ngIf="element.status == 'pending'" [disabled]="loading" class="btn-authorize" (click)="authorize(element.requestId)">Authorize</button>

                        <button *ngIf="element.status == 'unpaid'" class="yellow">Not-Paid</button>
                        <button *ngIf="element.status == 'paid'" class="green">Paid</button>
                    </div>

                </mat-cell>
            </ng-container>

            <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
            <mat-row mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
        </mat-table>
        <mat-paginator [pageSizeOptions]="[5, 10, 20,50,100]" [pageSize]="20" ></mat-paginator>

    </div>

</section>
